{% extends "crud.html" %}


{% block sub_head %}
    <style>
        .gray-bg {background-color: #f5f5f5}
    </style>
{% endblock %}


{% block top_records_navigation %}
    <div class="col"></div>
{% endblock %}


{% block add_form %}
<div class="row">
    <div class="col-12" data-product-container>
        <h5>List of Products</h5>
        <div class="row">
            <div class="col-12 col-md-3">
                <a class="btn btn-warning btn-sm btn-block" href="javascript:;" data-product-toggle="add"> <i class="fa fa-plus"></i> Add Product</a>
            </div>
        </div>
    </div>
</div>
<div class="row">
    <div class="col-12">
        <h5>Raw Materials</h5>
        <table class="table table-striped table-hover table-bordered">
            <thead>
                <tr>
                    <th>Item Code</th>
                    <th>Description</th>
                    <th>Unit</th>
                    <th>Required</th>
                    <th>Stock on Hand</th>
                    <th>On Hold</th>
                    <th>Delta</th>
                </tr>
            </thead>
            <tbody data-materials-editable-container="raw_materials"></tbody>
        </table>
    </div>
</div>
<div class="row">
    <div class="col-12">
        <h5>Packaging Materials</h5>
        <table class="table table-striped table-hover table-bordered">
            <thead>
                <tr>
                    <th>Item Code</th>
                    <th>Description</th>
                    <th>Unit</th>
                    <th>Required</th>
                    <th>Stock on Hand</th>
                    <th>On Hold</th>
                    <th>Delta</th>
                </tr>
            </thead>
            <tbody data-materials-editable-container="packaging_materials"></tbody>
        </table>
    </div>
</div>
{% endblock %}


{% block empty_spiel %}
    Create Forecasts for multiple products
    <br />
    Check real time status of required materials.
{% endblock %}


{% block read_columns %}
{# <script> #}
    {
        data: 'forecast_no',
        render: function(data, type) {
            if (type === 'sort') {
                return data;
            } else {
                return '<a href="javascript:;" data-crud-toggle="details" class="font-weight-bold" aria-expanded="true"> #{0}</a>'.format(data);
            }
        }
    },
    {
        data: 'date_last_modified'
    },
    {
        data: 'last_modified_by'
    },
    {
        data: '_id',
        sortable: false,
        className: 'text-center',
        render: function(data, type, row) {
            return '<a href="javascript:;" class="btn btn-danger btn-sm btn-block" data-crud="delete" data-delete-target="{0}"><i class="fa fa-trash fa-fw"></i> Delete</a>'.format(data);
        }
    },
{# </script> #}
{% endblock %}


{% block sub_scripts %}
{# <script> #}
    $dom.document.on('click', '[data-product-toggle="add"]', function() {
        $c = $(this).closest('[data-product-container]');
        color = ($c.find('.row').length%2) ? 'gray-bg' : '';
        $c.find('.row:last').after(`
            <div class="row {0}" data-form-dynamic>
                <!--
                <div class="col-4 offset-8 col-md-3 offset-md-9">
                    <a href="javascript:;" class="btn btn-secondary btn-sm btn-block" data-product-toggle="delete"> Delete Product</a>
                </div>
                -->
                <div class="col-6 col-md-4">
                    <div class="form-group">
                        <label><b>Product Code*</b></label>
                        <select name="finished-goods-formula_no" class="form-control" data-ajax-select-target="/api/v1/formulas/all?valid=True&fields=product_code,description,variant" data-ajax-select-value="_id" data-ajax-select-label="product_code,description,variant" required placeholder="-- Select Product Code --">
                            <option value="">-- Select Product Code --</option>
                        </select>
                    </div>
                </div>
                <div class="col-6 col-md-4">
                    <div class="form-group">
                        <label>Bulk (kgs)</label>
                        <div class="input-group input-group-sm">
                            <input type="number" name="finished-goods-bulk-weight" class="form-control" min="0" step="0.0001" data-default-value="0" value="0" style="border-top-left-radius:30px;border-bottom-left-radius:30px" />
                            <div class="input-group-append">
                                <div class="input-group-text" style="border-top-right-radius:30px;border-bottom-right-radius:30px;padding-left:50px">= 0 pieces</div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-6 col-md-4">
                    <div class="form-group">
                        <label>Bulk (pcs)</label>
                        <div class="input-group input-group-sm">
                            <input type="number" name="finished-goods-bulk-quantity" class="form-control" min="0" step="0.0001" data-default-value="0" value="0" style="border-top-left-radius:30px;border-bottom-left-radius:30px" />
                            <div class="input-group-append">
                                <div class="input-group-text" style="border-top-right-radius:30px;border-bottom-right-radius:30px;padding-left:50px">= 0 kgs</div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        `.format(
            color
        ));
        $c.find('.row:last [data-ajax-select-target]').ajaxDropdown();
    });

    // $dom.document.on('click', '[data-product-toggle="delete"]', function() {
    //     $c = $(this).closest('[data-product-container]');
    //     $self = $(this);
    //     Swal.fire({
    //         type: 'question',
    //         title: 'Delete Product',
    //         text: 'Unsaved information will be removed',
    //         showCancelButton: true,
    //         focusCancel: true,
    //         confirmButtonText: 'Yes'
    //     }).then((result) => {
    //         if (result.value) {
    //             $self.closest('.row[data-form-dynamic]').remove();
    //             $.each($c.find('.row[data-form-dynamic]'), function(i, v) {
    //                 $(v).removeClass('gray-bg');
    //                 if (i % 2 == 0) {
    //                     $(v).addClass('gray-bg');
    //                 }
    //             });
    //         }
    //     });
    // });

    $dom.document.on('change', 'select[name="finished-goods-formula_no"]', function() {
        let _id = $(this).val();
        let crud = $(this).closest('[data-crud]').attr('data-crud');
        let $dynamic_form = $(this).closest('[data-form-dynamic]');

        if (_id !== '' && _id !== null) {
            $.get('/api/v1/formulas?_id={0}&fields=raw_materials,packaging_materials,standard_packing_per_piece,standard_specific_gravity'.format(_id), function() {})
            .done(function(response) {
                let xhrs = {};
                let rows = {};

                $dynamic_form.find('[name="finished-goods-bulk-weight"]').attr('data-equivalent-factor', parseFloat(1 / response.standard_packing_per_piece / response.standard_specific_gravity * 1000));
                $dynamic_form.find('[name="finished-goods-bulk-quantity"]').attr('data-equivalent-factor', parseFloat(response.standard_packing_per_piece * response.standard_specific_gravity / 1000));

                $.each(['raw_materials', 'packaging_materials'], function(i1, category) {
                    if (!$('[data-crud="{0}"] [data-materials-editable-container="{1}"] [data-item-code]'.format(crud, category)).length) {
                        $('[data-crud="{0}"] [data-materials-editable-container="{1}"]'.format(crud, category)).html('<tr><td colspan="7">Loading...</td></tr>');
                    }
                    xhrs[category] = [];
                    rows[category] = Array(response[category].length);
                    $.each(response[category], function(i2, v) {
                        xhrs[category].push(
                            (function() {
                                return $.get('/api/v1/raw_materials?_id={0}&fields=item_code,description,default_unit,stock_on_hand,stock_on_hold,status'.format(v.item_code), function() {})
                                .done(function(response2) {
                                    let factors = '';
                                    if (category === 'raw_materials') {
                                        factors = parseFloat(v.quantity) / 100;
                                    } else {
                                        factors = parseFloat(v.quantity).toFixed(6);
                                    }
                                    factors = '{0}:{1}'.format(response._id, factors)

                                    if (!$('[data-crud="{0}"] [data-materials-editable-container="{1}"] [data-item-code="{2}"]'.format(crud, category, response2.item_code)).length) {
                                        {% if request.debug %}
                                        // Row DNE
                                        console.debug('forecast: adding {0} {1}'.format(response2.item_code, v.index));
                                        {% endif %}
                                        rows[category][v.index] = `
                                        <tr data-form-dynamic data-item-code="{0}">
                                            <td>{0}</td>
                                            <td>{1}</td>
                                            <td>{2}</td>
                                            <td class="text-right" data-factors="{3}"></td>
                                            <td class="text-right">{4}</td>
                                            <td class="text-right">{5}</td>
                                            <td class="text-right">0.0000</td>
                                        </tr>`.format(
                                            response2.item_code,
                                            response2.description,
                                            response2.default_unit,
                                            factors,
                                            parseFloat(response2.stock_on_hand).toFixed(6),
                                            parseFloat(response2.stock_on_hold).toFixed(6)
                                        );
                                    } else {
                                        {% if request.debug %}
                                        // Row Exists
                                        console.debug('forecast: item {0} exists'.format(response2.item_code));
                                        {% endif %}
                                        rows[category][v.index] = '';
                                        $current_factors = $('[data-crud="{0}"] [data-materials-editable-container="{1}"] [data-item-code="{2}"] > td:eq(3)'.format(crud, category, response2.item_code));
                                        current_factors = $current_factors.attr('data-factors');
                                        current_factors += ',' + factors;
                                        $current_factors.attr('data-factors', current_factors);
                                    }
                                });
                            })()
                        )
                    });

                    $.when.apply(null, xhrs[category]).then(function() {
                        if (!$('[data-crud="{0}"] [data-materials-editable-container="{1}"] [data-item-code]'.format(crud, category)).length) {
                            $('[data-crud="{0}"] [data-materials-editable-container="{1}"]'.format(crud, category)).html('');
                        }
                        $('[data-crud="{0}"] [data-materials-editable-container="{1}"]'.format(crud, category)).append(rows[category].join(''));
                        $('[data-crud="{0}"] input[name="finished-goods-quantity"]:last'.format(crud)).resetCustom();
                    });
                })
            })
            .fail(function(response) {
                console.log('error ajax')
            });
        } else {

        }
    });

    $dom.document.on('keyup mouseup input', 'input[name="finished-goods-bulk-weight"],input[name="finished-goods-bulk-quantity"]', function() {
        let crud = $(this).closest('[data-crud]').attr('data-crud');
        let $self = $(this);
        let value = $self.val();

        $self.closest('.input-group').find('.input-group-text').html('= {0} {1}'.format(parseInt(value*$self.attr('data-equivalent-factor')), ($self.attr('name') === 'finished-goods-bulk-weight') ? 'pieces': 'kgs'));

        {# Raw Materials #}
        $.each($('[data-crud="{0}"] [data-materials-editable-container={1}] tr[data-form-dynamic]'.format(crud, 'raw_materials')), function(i2, v) {
            let factors = $(v).find('[data-factors]').attr('data-factors');
            let required = parseFloat(0);
            $.each(factors.split(','), function(i3, v2) {
                let formula_no = v2.split(':')[0];
                let factor = v2.split(':')[1];

                let $row = $('option[value="{0}"]:selected'.format(formula_no)).closest('.row');
                let quantity = parseInt($row.find('[name="finished-goods-bulk-weight"]').val() || 0);
                    quantity += + parseInt($row.find('[name="finished-goods-bulk-quantity"]').siblings('.input-group-append').find('.input-group-text').html().replace('= ', '').replace(' kgs', '') || 0);

                required += parseFloat(factor) * parseFloat(quantity);
            })

            $(v).find('td:eq(3)').html(required.toFixed(6));

            let stock_on_hand = $(v).find('td:eq(4)').html();
            if (stock_on_hand == '--') {
                $(v).find('td:eq(6)').html('--');
            } else {
                delta = parseFloat($(v).find('td:eq(4)').html()) + parseFloat($(v).find('td:eq(5)').html()) - required;
                $(v).find('td:eq(6)').html(delta.toFixed(6));
            }
        });

        {# Packaging Materials #}
        $.each($('[data-crud="{0}"] [data-materials-editable-container={1}] tr[data-form-dynamic]'.format(crud, 'packaging_materials')), function(i2, v) {
            let factors = $(v).find('[data-factors]').attr('data-factors');
            let required = parseFloat(0);
            $.each(factors.split(','), function(i3, v2) {
                let formula_no = v2.split(':')[0];
                let factor = v2.split(':')[1];

                let $row = $('option[value="{0}"]:selected'.format(formula_no)).closest('.row');
                let quantity = parseInt($row.find('[name="finished-goods-bulk-quantity"]').val() || 0);
                    quantity += + parseInt($row.find('[name="finished-goods-bulk-weight"]').siblings('.input-group-append').find('.input-group-text').html().replace('= ', '').replace(' pieces', '') || 0);

                required += parseFloat(factor) * parseFloat(quantity);
            })

            $(v).find('td:eq(3)').html(required.toFixed(6));

            let stock_on_hand = $(v).find('td:eq(4)').html();
            if (stock_on_hand == '--') {
                $(v).find('td:eq(6)').html('--');
            } else {
                delta = parseFloat($(v).find('td:eq(4)').html()) + parseFloat($(v).find('td:eq(5)').html()) - required;
                $(v).find('td:eq(6)').html(delta.toFixed(6));
            }
        });
    });
{# </script> #}
{% endblock %}
